/*

                   +----------+                
                   | DList<T> |<--------------------+                
                   +----------+                     |
	               +----------+                     |
                         |                          |
                        / \                         | 
                        ---                         |                    
                         |                          |
           ---------------------------              |
           |                         |              |
    +-------------+          +-------------------+  |
    | DMTList<T>  |          | DConsList<T>      |  |
    +-------------+          +-------------------+  |
    +-------------+      +---| DList<T> previous |  |  
                         |   | T        Data     |  |
                         +---| DList<T> next     |  |  
                         |   +-------------------+  |
                         +--------------------------+

*/

			 
abstract class DList<T> {
    
    public String toString(){ return toString("             "); }
    abstract String toString(String acc);

}

// Represents an empty doubly linked list of T
class DMtList<T> extends DList<T>{

   public DMtList(){}

   String toString(String acc){ return acc; }
}


// Represents a Non-empty doubly linked list of T
class DConsList<T> extends DList<T>{
    DList<T> previous;
    T data;
    DList<T> next;

    // Basic Constructor
    public DConsList(T data, DList<T> previous , DList<T> next){
        this.data = data;
        this.previous = previous;
	this.next = next;
    }

    String toString(String acc){ 
        return acc+"( "+this.data+", \n"+this.next.toString(acc+"    ")+")";
    }
}




